
local brez = CreateFrame("Frame", "bRez", UIParent)
brez:SetPoint("CENTER", UIParent, "CENTER")
brez:SetWidth(100)
brez:SetHeight(30)
brez:EnableMouse(true)
brez:RegisterForDrag("LeftButton")
brez:SetClampedToScreen(true)
brez:SetMovable(true)
brez:RegisterEvent("PLAYER_LOGIN")
brez:SetScript("OnEvent", function(frame, event, ...) frame[event](frame, ...) end)
brez:SetScript("OnDragStart", function(frame) if IsAltKeyDown() then frame:StartMoving() end end)
brez:SetScript("OnDragStop", function(frame) frame:StopMovingOrSizing() end)

brez.cooldown = brez:CreateFontString("bRezCooldownText", "OVERLAY")
brez.cooldown:SetHeight(20)
brez.cooldown:SetPoint("TOPLEFT", brez, "TOPLEFT")
brez.cooldown:SetFontObject(TextStatusBarText)
brez.cooldown:SetJustifyH("LEFT")

brez.ready = brez:CreateFontString("bRezReadyText", "OVERLAY")
brez.ready:SetHeight(20)
brez.ready:SetPoint("BOTTOMLEFT", brez.cooldown, "BOTTOMLEFT", 0 , -10)
brez.ready:SetFontObject(TextStatusBarText)
brez.ready:SetJustifyH("LEFT")

brez.count = brez:CreateFontString("bRezCountText", "OVERLAY")
brez.count:SetHeight(50)
brez.count:SetPoint("RIGHT", brez, "LEFT", -2, -2)
brez.count:SetFont("Fonts\\FRIZQT__.TTF", 20, "OUTLINE")
brez.count:SetJustifyH("CENTER")

local theDead, count = {}, 0
function brez:ZONE_CHANGED_NEW_AREA()
	local _, type, _, _, maxPlayers = GetInstanceInfo()
	if type == "raid" then
		if not self.isEngaged then
			count = maxPlayers == 10 and 1 or 3
		end
		self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
		self:RegisterEvent("INSTANCE_ENCOUNTER_ENGAGE_UNIT")
		self:RegisterEvent("RAID_ROSTER_UPDATE")
		self.count:SetFormattedText("|cFF00FF7F%d|r", count)
		self:Show()
	else
		if self:IsShown() then
			self:UnregisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
			self:UnregisterEvent("INSTANCE_ENCOUNTER_ENGAGE_UNIT")
			self:UnregisterEvent("RAID_ROSTER_UPDATE")
			self:Hide()
			wipe(theDead)
			self.isEngaged = nil
		end
	end
end

function brez:PLAYER_LOGIN()
	if not bRezDB then bRezDB = {} end
	self:RegisterEvent("ZONE_CHANGED_NEW_AREA")
	self:ZONE_CHANGED_NEW_AREA()
end

function brez:INSTANCE_ENCOUNTER_ENGAGE_UNIT()
	local n = UnitHealth("boss1") > 100 or UnitHealth("boss2") > 100 or UnitHealth("boss3") > 100 or UnitHealth("boss4") > 100
	if not n and self.isEngaged then
		self.isEngaged = nil
		local maxPlayers = select(5, GetInstanceInfo())
		count = maxPlayers == 10 and 1 or 3
		self.count:SetFormattedText("|cFF00FF7F%d|r", count)
		wipe(theDead)
	elseif not self.isEngaged and n then
		self.isEngaged = true
		local maxPlayers = select(5, GetInstanceInfo())
		count = maxPlayers == 10 and 1 or 3
		self.count:SetFormattedText("|cFF00FF7F%d|r", count)
		wipe(theDead)
	end
end

local redemption, feign, lastCheck = GetSpellInfo(27827), GetSpellInfo(5384), 0
local minutes, seconds, ready, cooldown = "%s("..strreplace(MINUTE_ONELETTER_ABBR, " ", "")..") ", "%s("..strreplace(SECOND_ONELETTER_ABBR, " ", "")..") ", "|cFF00FF7F"..READY.."|r: ", "|cFFFF0000"..ON_COOLDOWN.."|r: "
function brez:COMBAT_LOG_EVENT_UNFILTERED(time, event, _, name, _, _, tarName, _, spellId, spellName)
	if spellId == 20484 and event == "SPELL_RESURRECT" then
		bRezDB[name] = time
		local tbl = CUSTOM_CLASS_COLORS or RAID_CLASS_COLORS
		local t = tbl[select(2, UnitClass(tarName))]
		local s = tbl[select(2, UnitClass(name))]
		print("|cFF33FF99bRez|r: ", ("|Hplayer:"..name.."|h|cFF%02x%02x%02x["..name.."]|r|h"):format(s.r * 255, s.g * 255, s.b * 255), ">>",
			"|cFFFF0000|Hspell:20484|h["..spellName.."]|h|r", ">>",
			("|Hplayer:"..tarName.."|h|cFF%02x%02x%02x["..tarName.."]|r|h"):format(t.r * 255, t.g * 255, t.b * 255)
		)
		if self.isEngaged then
			theDead[tarName] = nil
			count = count - 1
			self.count:SetFormattedText("%s%d|r", count > 0 and "|cFF00FF7F" or "|cFFFF0000", count)
		end
	end

	--Lots of lovely checks before adding someone to the deaths table
	if event == "UNIT_DIED" and self.isEngaged and UnitIsPlayer(tarName) and not UnitIsFeignDeath(tarName) and not UnitBuff(tarName, redemption) and not UnitBuff(tarName, feign) then
		theDead[tarName] = true
		--block another update for 3sec to prevent issues
		lastCheck = time
		return
	end

	if time - lastCheck < 3 then return end

	for k in pairs(theDead) do
		if UnitBuff(k, redemption) or UnitBuff(k, feign) or UnitIsFeignDeath(k) then --the backup plan, you need one with Blizz
			theDead[k] = nil
		elseif not UnitIsDeadOrGhost(k) then
			local tbl = CUSTOM_CLASS_COLORS or RAID_CLASS_COLORS
			local class = select(2, UnitClass(k))
			local s = tbl[class]
			if class == "SHAMAN" then
				print("|cFF33FF99bRez|r: ", ("|Hplayer:"..k.."|h|cFF%02x%02x%02x["..k.."]|r|h"):format(s.r * 255, s.g * 255, s.b * 255), ">>",
					"|cFFFF0000|Hspell:20608|h["..GetSpellInfo(20608).."]|h|r"
				)
			else
				print("|cFF33FF99bRez|r: ", ("|Hplayer:"..k.."|h|cFF%02x%02x%02x["..k.."]|r|h"):format(s.r * 255, s.g * 255, s.b * 255), ">>",
					"|cFFFF0000|Hspell:20707|h["..GetSpellInfo(20707).."]|h|r"
				)
			end
			count = count - 1
			self.count:SetFormattedText("%s%d|r", count > 0 and "|cFF00FF7F" or "|cFFFF0000", count)
			theDead[k] = nil
		end
	end
	lastCheck = time
	local cdnames = cooldown
	local readynames = ready
	for k, v in pairs(bRezDB) do
		if v > 0 then
			local timeleft = 600 - (time - v)
			if timeleft > 60 then
				cdnames = cdnames .. (minutes):format(k, ceil(timeleft / 60))
			elseif timeleft < 4 then
				bRezDB[k] = 0
				readynames = readynames .. (UnitIsDeadOrGhost(k) and "|cFFFF0000"..k or "|cFFFFFFFF"..k) .. ". |r"
			else
				cdnames = cdnames .. (seconds):format(k, timeleft)
			end
		else
			readynames = readynames .. (UnitIsDeadOrGhost(k) and "|cFFFF0000"..k or "|cFFFFFFFF"..k) .. ". |r"
		end
	end
	self.cooldown:SetText(cdnames)
	self.ready:SetText(readynames)
end

function brez:RAID_ROSTER_UPDATE()
	local _, type, _, _, maxPlayers = GetInstanceInfo()
	if type ~= "raid" then return end

	for k in pairs(bRezDB) do
		if not UnitInRaid(k) then
			bRezDB[k] = nil
		end
	end
	for k in pairs(theDead) do
		if not UnitInRaid(k) then
			theDead[k] = nil
		end
	end

	for i = 1, GetNumRaidMembers() do
		local player, _, subgroup, _, _, class = GetRaidRosterInfo(i)
		if class == "DRUID" then
			if subgroup <= maxPlayers/5 then
				if not bRezDB[player] then
					bRezDB[player] = 0
				end
			else
				bRezDB[player] = nil
			end
		end
	end
end

